import com.sun.javadoc.*;
import java.util.*;
import java.io.*;

public class TEntry implements Comparable {
    public String name;
    public int whichword;
    public String word;
    public List words;
    public Doc doc;

    public TEntry(RiEntry ent, int ww, String sw, List w) {
	name = ent.name; whichword = ww; 
	word = sw;
	words = w; 
	doc = ent.doc;
    }

    public String getWord() {
	return word;
    }

    public String toString() {
	return word;
    }

    public String abbrevName(String name) {
	int ix, len;
	if (name.length() <= InvertedIndex.NAME_LIMIT) return name;
	for(len = name.length(); 
	    len > InvertedIndex.NAME_LIMIT; 
	    len = name.length()) 
	{
	    ix = name.indexOf(".");
	    if (ix < 0) break;
	    else name = name.substring(ix + 1);
	}
	return "..." + name;
    }

    public String formatName() {
	if (doc.isInterface()) {
	    return "<i>" + abbrevName(name) + "</i>";
	}
	else return abbrevName(name);
    }

    public String formatNameFull() {
	if (doc.isInterface()) {
	    return "<i>" + name + "</i>";
	}
	else return name;
    }

    public int compareTo(Object o) {
	TEntry that = (TEntry)o;
	int ret = word.compareTo(o.toString());
	if (ret == 0) {
	    int wp1, wp2;
	    wp1 = this.whichword;
	    wp2 = that.whichword;
	    for( ; ret == 0 && wp1 < words.size() && wp2 < that.words.size(); wp1++, wp2++) {
		ret = words.get(wp1).toString().compareToIgnoreCase(that.words.get(wp2).toString());
	    }	    
	}
	return ret;
    }

}

